<? include("std.inc"); ?>
<? include("header.inc"); ?>
<? include("docs.inc"); ?>

<?
func_title("image");
args("file", "filename", "Image filename to display");
args("extra", "text", "Any extra parameters, such as \"border=1\"", 0, "", "None");
args("alt", "text", "Contents of the ALT tag.", 0, "", "Image filename");
args(-1);

?>

Displays an image.  This function replaces the &lt;img src=""&gt; tag,
but only for images which are stored on the local server.  To display images
stored on other sites, use the regular HTML tags instead.
<p>
image() automatically adds width and height tags for you, and sets border=0.
Besides adding these things for you, its other purpose is to provide
inheritance.  It searches parent directories and <i>gfx/</i> directories
to find the image you ask for.
<p>
Currently, the alt tag is ignored.  This will be fixed later.

<p>
  
Example:

<table border=1 width="100%">
  <tr><td width="50%">Code</td><td width="50%">Result</td></tr>
  <tr><td width="50%" valign=top>
<pre>
&lt;?
  // This image is really in ../../../gfx/fishbtn.jpg 
  // but we don't care because image() finds it for us.  
  image("fishbtn.jpg"); 
?&gt;
</pre>
  </td>
  <td width="50%">
<? 
  // This image is really in ../../../gfx/fishbtn.jpg but we don't care
  // because image() finds it for us.  
  image("fishbtn.jpg"); 
?>
  </td></tr>
</table>

<? include("footer.inc"); ?>
