<?
function get_dir_array($sPath)
{
   //Load Directory Into Array
   $files = array();
   $handle=opendir($sPath);
   while ($file = readdir($handle))
   {
      if($file != "."  and  $file != "..")
	$files[count($files)] = $file;
   }
   //Clean up and sort
   closedir($handle);
   if(sizeof($files) > 1)
      sort($files);
   return $files;
}


function is_newer($a, $b)
{
   // Compare two file dates
   // "is $a newer than $b"?
   $a_stat = stat($a);
   $b_stat = stat($b);

   return ($a_stat[9] > $b_stat[9]);
}

function rmdir_recursive ($dirName)
{
   $d = opendir ($dirName);
   while($entry = readdir($d)) {
      if ($entry != "." && $entry != ".." && $entry != "") {
	 if (Is_Dir($dirName."/".$entry)) {
	    rmdir_recursive($dirName."/".$entry);
	 } else {
	    unlink ($dirName."/".$entry);
	 }
      }
   }
   closedir($d);
   rmdir ($dirName);
}

/**
 * Copy a file, or recursively copy a folder and its contents
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     1.0.1
 * @param       string   $source    Source path
 * @param       string   $dest      Destination path
 * @return      bool     Returns TRUE on success, FALSE on failure
 */
function copyr($source, $dest)
{
	// Simple copy for a file
	if (is_file($source)) {
		return copy($source, $dest);
	}

	// Make destination directory
	if (!is_dir($dest)) {
		mkdir($dest);
	}

	// Loop through the folder
	$dir = dir($source);
	while (false !== $entry = $dir->read()) {
		// Skip pointers
		if ($entry == '.' || $entry == '..') {
			continue;
		}

		// Deep copy directories
		if ($dest !== "$source/$entry") {
			copyr("$source/$entry", "$dest/$entry");
		}
	}

	// Clean up
	$dir->close();
	return true;
}

?>
