<?
function dir_normalize($path)
{
	// Do path mangling and return both the real and virtual location
	// of the specified path.

	//global $realwwwroot;
	global $DOCUMENT_ROOT;
	$DOCUMENT_ROOT = realpath($DOCUMENT_ROOT);

	$orig = $path;

	// Allow absolute links starting from wwwroot
	if(substr($path, 0, 1) == "/")
	{
		$path = $DOCUMENT_ROOT . $orig;
		//echo "DOCUMENT_ROOT: {$DOCUMENT_ROOT}<br>\n";
	}
	else
	{
		$path = realpath($orig);
	}
	//printf("realpath(%s) -> %s<br>\n", $orig, $path);

	//$path = substr($path, strlen($DOCUMENT_ROOT));
	$wwwpath = str_replace($DOCUMENT_ROOT, "", $path);

	// This usually indicates that a file is symlinked outside wwwroot
	if($wwwpath == $path)
	{
		// I'm not sure what do to here.
		// It just reverts to relative links, which seems okay.
		$wwwpath = $orig;
		$wwwpath = str_replace("/./", "/", $wwwpath);
	}

	//printf("fixedpath: %s<br>\n", $path);

	if(!$path) return array($orig, $orig);
	//printf("find_parents() -> %s, %s<br>\n", $wwwpath, $path);
	return array($wwwpath, $path);
}

function remove_args($url)
{
	// Converts "page.php?foo=bar" to "page.php"
	// TODO: this is totally unnecessary!  Remove it.
	$index = strpos($url, "?");
	//printf("<!-- DEBUG: index = %s -->\n", $index);
	if ($index  and  $index >= 0)
	{
		$text = substr($url, 0, $index);
		//printf("<!-- DEBUG: %s -> %s-->\n", $url, $text);
		$url = $text;
	}

	return $url;
}

function search_parents($filename, $directory="")
{
	// Provides "inheritance" in a somewhat object-oriented manner.
	// Similar to what Zope does.
	global $inherit_path;

	//print "search_parents({$filename})<br>\n";

	$fixed_filename = remove_args($filename);

	// This had been removed..  but why?
	// Reinstated, to make menus able to specify absolute addresses.
	// Requires that $DOCUMENT_ROOT is set in vars.inc
	if(substr($filename, 0, 1) == "/")
	{
		$check = dir_normalize($filename);
		return $check;
	}

	foreach($inherit_path as $path)
	{
		$check = $path . "/" . $fixed_filename;
		$urlcheck = $path . "/" . $filename;
		if (file_exists($check))
		{
			$check = dir_normalize($urlcheck);
			//printf("Found: %s -&gt; %s - %s<br>\n", $urlcheck, $check[0], $check[1]);
			return $check;
		}
		if ($directory)
		{
			$check = $path . "/" . $directory . "/" . $fixed_filename;
			$urlcheck = $path . "/" . $directory . "/" . $filename;
			if (file_exists($check))
			{
				$check = dir_normalize($urlcheck);
				return $check;
			}
		}
	}
	return "";
}

function look_parents($file, $path="")
{
	global $DOCUMENT_ROOT;
	$realfile=$file;
	/*
	if ($file[0] == "/")
	{
		$realfile = $DOCUMENT_ROOT . $file;
	}
	else
	*/
	{
		$vfile = search_parents($file, $path);
		if(! $vfile)
		{
			printf("<!-- Error: unable to find file %s -->", $file);
			return;
		}
		$realfile = $vfile[1];
		$file = $vfile[0];
	}

	return array($file, $realfile);
}

function image($file, $alt="", $extra="")
{
	// Automatically add wid/hgt (and other) tags to images...
	//$stuff = look_parents($file, "gfx");
	$stuff = search_parents($file, "gfx");
	if(!$stuff) return;

	$file = $stuff[0];
	$realfile = $stuff[1];

	// Generate alt tags based on image filename
	if($alt == "")
	{
		$alt = basename($realfile);
	}

	$size = GetImageSize($realfile);
	if($extra)
	{
		$text = sprintf("<img src=\"%s\" alt=\"%s\" %s border=\"0\" />",
				$file, $alt, $extra);
	}
	else
	{
		$text = sprintf("<img src=\"%s\" alt=\"%s\" %s border=\"0\" />",
				$file, $alt, $size[3]);
	}
	echo $text;
}

function bg_image($file)
{
	// Used inside a <body> or <table> tag, instead of background="foo.png"
	// $stuff = look_parents($file, "gfx");
	$stuff = search_parents($file, "gfx");
	if(!$stuff) return;

	$file = $stuff[0];
	$realfile = $stuff[1];

	printf("background=\"%s\"", $file);
}

function page($file, $text="", $extra="")
{
	print make_page($file, $text, $extra);
}

function make_page($file, $text="", $extra="")
{
	// Link to another page on this site.
	// I wanted to call it link(), but php doesn't allow me to override
	// the existing function.
	global $strip_extensions;

	if("http" == substr($file, 0, 4) )
	{
		$str = "<a href=\"{$file}\" $extra>{$text}</a>";
		return $str;
	}

	//$stuff = look_parents($file, "");
	$stuff = search_parents($file, "");
	if(!$stuff) return;

	$file = $stuff[0];
	$realfile = $stuff[1];

	if ($strip_extensions) {
		if (substr($file, -4) == ".php") {
			$file = substr($file, 0, strlen($file) -4);
		}
	}

	if(! $text)
	{
		$text = $file;
	}

	return "<a href=\"{$file}\" $extra>{$text}</a>";
}

function href($file, $text="", $extra="")
{
	// Link to another page on this site.
	// I wanted to call it file(), but php doesn't allow me to override
	// the existing function.
	//$stuff = look_parents($file, "files");
	$stuff = search_parents($file, "files");
	if(!$stuff) return;

	if(!$text) {$text = $file;}
	$file = $stuff[0];
	$realfile = $stuff[1];

	printf("<a href=\"%s\" $extra>%s</A>",
			$file, $text);
}

function array_has_key($arr, $k)
{
	return in_array($k, array_keys($arr));
}
?>
