<? include("std.inc"); ?>
<?
   $titles = array(
     "" => "",
     "file_edit" => ": File Editor",
     "save_file" => ": Save File",
     "upload_file" => ": Upload File",
     "add_file_form" => ": Add File",
     "create_new_file" => ": New File",
     "create_new_dir" => ": New Directory",
     "rename" => ": Rename File(s)",
   );
   $t = $titles[$action];
   $title = "{$site_name}{$t}";
?>
<? include("header.inc"); ?>

<?
function get_filelist($search="filelist:", $v_check = "on")
{
   // Figure out which files were checked on the previous page view,
   // and return them as an array
   global $HTTP_POST_VARS;
   global $EDIT_DOCUMENT_ROOT;

   $searchlen = strlen($search);

   $retlist = array();

   trans_post_vars();
   $vars = post_var_search($search);
   foreach ($vars as $k => $v)
   {
      if($v == $v_check)
      {
	 array_push($retlist, $k);
      }
   }

   /* DELME
   $i = 0;
   foreach ($HTTP_POST_VARS as $k => $v)
   {
      //$k = trans_var($k);
      //printf("POST: %s  =>  %s<br>\n", $k, $v);
      $check = substr($k, 0, $searchlen);
      if ($check == $search   and   $v == $v_check)
      {
	 $rest = substr($k, $searchlen);
	 $retlist[$i] = $rest;
	 $i++;
      }
   }
   */

   return $retlist;
}

function handle_copy_button($auth_user)
{
   // Copies checked file list into user's clipboard
   $filelist = get_filelist();

   /*
   foreach($filelist as $f)
      {
	 printf("File: %s<br>\n", $f);
      }
   */
   
   $auth_user->filelist = $filelist;
   $auth_user->filemode = "copy";
}

function handle_cut_button($auth_user)
{
   // Copies checked file list into user's clipboard
   $filelist = get_filelist();

   /*
   foreach($filelist as $f)
      {
	 printf("File: %s<br>\n", $f);
      }
   */
   
   $auth_user->filelist = $filelist;
   $auth_user->filemode = "cut";
}

function delete_files($auth_user)
{
   // Remove checked files from the filesystem
   // TODO: implement recursive directory deletion?
   global $EDIT_DOCUMENT_ROOT;
   
   $dellist = get_filelist();
   
   foreach ($dellist as $f)
   {
      $path = $f;
      $realpath = $EDIT_DOCUMENT_ROOT . $f;

      printf("Delete: %s (%s)<br>\n", $path, $realpath);
      
      if(is_dir($realpath))
      {
	 // TODO: Add a recursive directory remover, which uses the
	 // permission system to ensure nobody deletes child directories
	 // they have been denied access to
	 //$err = rmdir($realpath);
	 $err = rmdir_recursive($realpath);
	 /*
	 $err = rmdir($realpath);
	 if(! $err)
	    printf("%s: Cannot yet recursively delete directories.  " .
		   "If you see any errors, please empty the directory " .
		   "manually and then try again.<br>\n",
		   $path);
	 */
      }
      else if (file_exists($realpath))
      {
	 if(auth_has_write($auth_user, $path))
	 {
	    printf("Delete: %s<br>\n", $realpath);
	    unlink($realpath);
	 }
      }
   }
}

function handle_paste_button($auth_user)
{
   global $EDIT_DOCUMENT_ROOT;
   global $page;
   
   $valid_operations = array("cut", "copy");
   
   if((! $auth_user->filelist)  or  (! $auth_user->filemode))
   {
      printf("No files to paste!<br>\n");
      return;
   }

   if(! in_array($auth_user->filemode, $valid_operations))
   {
      printf("Invalid operation.<br>\n");
      return;
   }
   
   printf("Action: %s<br>\n", $auth_user->filemode);

   foreach($auth_user->filelist as $f)
   {
      printf("File: %s<br>\n", $f);

      $real_sourcepath = $EDIT_DOCUMENT_ROOT . $f;
      $real_destpath = $EDIT_DOCUMENT_ROOT . $page . "/" . basename($f);
      $virt_sourcepath = $f;
      $virt_destpath = $page . "/" . basename($f);

      //printf("rs: %s<br>\n", $real_sourcepath);
      //printf("rd: %s<br>\n", $real_destpath);
      //printf("vs: %s<br>\n", $virt_sourcepath);
      //printf("vd: %s<br>\n", $virt_destpath);

      // Check for write permission for src file
      // Check for write permission in dest file
      if((! auth_has_write($auth_user, $virt_sourcepath))  or
	 (! auth_has_write($auth_user, $virt_destpath)))
      {
	 printf("Unauthorized.  (%s -> %s><br>\n",
		$virt_sourcepath, $virt_destpath);
	 continue;
      }
      
      if($auth_user->filemode == "copy")
      {
	 // Copy file
	 if(! copy($real_sourcepath, $real_destpath))
	 {
	    printf("Copy failed for %s -> $s.\n",
		   $virt_sourcepath, $virt_destpath);
	 }
      }
      else if($auth_user->filemode == "cut")
      {
	 // Move file
	 if(! rename($real_sourcepath, $real_destpath))
	 {
	    printf("Rename failed for %s -> $s.\n",
		   $virt_sourcepath, $virt_destpath);
	 }
      }
   }

   $auth_user->filelist = array();
   $auth_user->filemode = "";
}

function handle_rename_button($auth_user)
{
   global $EDIT_DOCUMENT_ROOT;
   global $page;
   
   printf("Rename files...<br>\n");
   $renamelist = get_filelist();

   $url = link_to_self("action", "rename");
   printf("<form method=post action=\"%s\">\n", $url);
   printf("<table>\n");
   
   foreach ($renamelist as $f)
   {
      $path = $f;
      $realpath = $EDIT_DOCUMENT_ROOT . $f;

      $base = basename($path);
      //printf("Rename: %s (%s)<br>\n", $path, $basename);
      
      if (file_exists($realpath))
      {
	 if(auth_has_write($auth_user, $path))
	 {
	    //printf("Rename: %s<br>\n", $base);
	    printf("<tr><td>\n");
	    printf("Rename <strong>%s</strong> to...\n", $base);
	    printf("</td><td>\n");
	    printf("<input type=text name=\"rename:%s\" value=\"%s\" /><br>\n",
		   trans_var($path), $base);
	    printf("</td></tr>\n");
	 }
      }
   }

   printf("</table>\n");

   printf("<input type=submit value=\"Go...\" /><br>\n");

   printf("</form>\n");

   $auth_user->filelist = array();
   $auth_user->filemode = "";
}

function handle_rename_form($auth_user)
{
   global $HTTP_POST_VARS;
   global $HTTP_GET_VARS;
   global $EDIT_DOCUMENT_ROOT;
   global $page;
   global $action;
   //global $encode_trans;
   
   $search_text = "rename:";
   $search_len = strlen($search_text);

   //$trans = array_flip($encode_trans);

   $action = "";
   $HTTP_GET_VARS["action"] = "";
   
   printf("Rename files...<br>\n");
   //$renamelist = get_filelist("rename:");
   $renamelist = array();

   trans_post_vars();
   $vars = post_var_search($search_text);
   foreach($vars as $k => $v)
   {
      $renamelist[$k] = $v;
   }

   /* DELME
   foreach ($HTTP_POST_VARS as $k => $v)
   {
      if(substr($k, 0, $search_len) == $search_text)
      {
	 $f = substr($k, $search_len);
	 $f_n = $v;
	 //$f = strtr($f, $trans);
	 
	 //printf("Rename: %s => %s<br>\n", $f, $f_n);
	 $renamelist[$f] = $f_n;
      }
   }
   */
   
   foreach ($renamelist as $f => $v)
   {
      $path = $f;
      $realpath = $EDIT_DOCUMENT_ROOT . $f;
      $newpath = dirname($f) . "/" . basename($v);
      $real_newpath = $EDIT_DOCUMENT_ROOT . $newpath;

      $base = basename($path);

      if(basename($v)  !=  $v)
      {
	 printf("Cannot rename %s -> %s:  To move files, use the " .
		"\"Cut\" and \"Paste\" buttons.<br>\n",
		$path, $v);
	 continue;
      }
      
      //printf("Rename: %s -> %s<br>\n", $path, $newpath);

      if($realpath == $real_newpath)
      {
	 printf("Ignoring %s -> %s: same file.<br>\n",
		$path, $newpath);
	 continue;
      }
      
      if (file_exists($realpath))
      {
	 if (file_exists($real_newpath))
	 {
	    printf("%s: File already exists!<br>\n", $real_newpath);
	    continue;
	 }
	 if(auth_has_write($auth_user, $path))
	 {
	    if(auth_has_write($auth_user, $newpath))
	    {
	       //printf("Rename: %s<br>\n", $base);
	       printf("Rename %s -> %s<br>\n", $path, $newpath);
	       rename($realpath, $real_newpath);
	    }
	    else
	    {
	       printf("%s: Unauthorized.<br>\n", $realpath);
	    }
	 }
	 else
	 {
	    printf("%s: Unauthorized.<br>\n", $path);
	 }
      }
   }

   dir_edit(&$auth_user, $page);
}

function handle_create_file($auth_user)
{
   global $EDIT_DOCUMENT_ROOT;
   global $text;
   global $filename;
   global $page;

   if(substr($filename, 0, 2) == "..")
   {
      printf("Invalid file name.<br>\n");
      return;
   }
   
   $virt_dest = $page . "/" . $filename;
   $real_dest = $EDIT_DOCUMENT_ROOT . $virt_dest;
   
   printf("File to create: %s<br>\n", $virt_dest);

   if(! auth_has_write($auth_user, $virt_dest))
   {
      printf("Unauthorized.<br>\n");
      return;
   }

   if (file_exists($real_dest))
   {
      printf("File already exists!  Aborting.<br>\n");
      return;
   }

   $fp = fopen($real_dest, "wb");
   if (! $fp)
   {
      printf("Unable to create file.<br>\n");
      return;
   }

   $data = reverse_htmlspecialchars($text);
   fwrite($fp, $data);
   fclose($fp);

   printf("File saved.<br>\n");

   $back_link = sprintf("index.php?page=%s", $virt_dest);
   printf("<a href=\"%s\">Edit %s</a><br>\n", $back_link, $virt_dest);
}

function handle_create_dir($auth_user)
{
   global $EDIT_DOCUMENT_ROOT;
   global $filename;
   global $page;

   if(substr($filename, 0, 2) == "..")
   {
      printf("Invalid file name.<br>\n");
      return;
   }
   
   $virt_dest = $page . "/" . $filename;
   $real_dest = $EDIT_DOCUMENT_ROOT . $virt_dest;
   
   printf("Dir to create: %s<br>\n", $virt_dest);

   if(! auth_has_write($auth_user, $virt_dest))
   {
      printf("Unauthorized.<br>\n");
      return;
   }

   if (file_exists($real_dest))
   {
      printf("File already exists!  Aborting.<br>\n");
      return;
   }

   $oldumask = umask(0);
   mkdir($real_dest, 0775);
   umask($oldumask);

   printf("Dir created.<br>\n");

   $back_link = sprintf("index.php?page=%s", $virt_dest);
   printf("<a href=\"%s\">Browse %s</a><br>\n", $back_link, $virt_dest);
}

function handle_create_ez($auth_user)
{
   global $EDIT_DOCUMENT_ROOT;
   global $filename;
   global $page;

   if(substr($filename, 0, 2) == "..")
   {
      printf("Invalid file name.<br>\n");
      return;
   }
   
   $virt_dest = $page . "/" . $filename;
   $real_dest = $EDIT_DOCUMENT_ROOT . $virt_dest;
   
   printf("EZ Page to create: %s<br>\n", $virt_dest);

   if(! auth_has_write($auth_user, $virt_dest))
   {
      printf("Unauthorized.<br>\n");
      return;
   }

   if (file_exists($real_dest))
   {
      printf("Page already exists!  Aborting.<br>\n");
      return;
   }

   printf("Creating new EZ-Page...<br>\n");

   $oldumask = umask(0);
   mkdir($real_dest, 0775);
   umask($oldumask);

   copy_skel($real_dest);

   printf("... done.<br>\n");

   $back_link = sprintf("index.php?page=%s", $virt_dest);
   printf("<a href=\"%s\">Browse %s</a><br>\n", $back_link, $virt_dest);
}

function copy_skel($dest)
{
   global $inherit_path;
   //echo "copy_skel({$dest})<br /><br />\n";
   $look = "php/skel";
   foreach ($inherit_path as $path)
   {
      // /home/www/site.com/section/page/../../php/skel
      //echo "checking... {$dest}/{$path}/{$look}<br /><br />\n";
      $check = realpath($dest . "/" . $path) . "/" . $look;
      //echo "checking... {$check}<br /><br />\n";
      if (file_exists($check))
      {
         // rcopy($look, $dest);
	 //echo "rcopy({$check}, {$dest})<br /><br />\n";
	 copyr($check, $dest);
	 return;
      }
   }
   echo "copy_skel(): failed.<br /><br />\n";
}

function new_ez_form($auth_user)
{
   global $page;

   //printf("New EZ form.<br>\n");
   
   if(!$page) $page = $auth_user->attribs["homedir"]->value;
   
   if(! auth_is_dir($auth_user, $page))
   {
      printf("Invalid directory.<br>\n");
      return;
   }

   if(! auth_has_write($auth_user, $page))
   {
      printf("Unauthorized.<br>\n");
      return;
   }

   $target = link_to_self("action", "create_new_ez");
   printf("<form method=post action=\"%s\">\n", $target);

   printf("Page Name:\n");
   printf("<input type=text name=filename value=\"newpage\"><br>\n");

   printf("<input type=submit name=\"save_button\" " .
	  "value=\"Create File\">\n");

   echo "</form>\n";
}

function new_php_form($auth_user)
{
   global $page;

   //printf("New PHP form.<br>\n");
   
   if(!$page) $page = $auth_user->attribs["homedir"]->value;
   
   if(! auth_is_dir($auth_user, $page))
   {
      printf("Invalid directory.<br>\n");
      return;
   }

   if(! auth_has_write($auth_user, $page))
   {
      printf("Unauthorized.<br>\n");
      return;
   }


   $content = "<?\ninclude(\"std.inc\");\n" .
      "\$title = \"{$site_name}: New Page\";\n" .
      "\$title_text = '<font size=\"+1\">{$site_name}:</font><br><font size=\"+2\">New Page</font>';\n" .
      "include(\"header.inc\");\n?>\n" .
      "\n" .
      "Put your content here.\n" .
      "\n" .
      "<? include(\"footer.inc\"); ?>\n";

   $target = link_to_self("action", "create_new_file");
   printf("<form method=post action=\"%s\">\n", $target);

   printf("File Name:\n");
   printf("<input type=text name=filename value=\"new.php\"><br>\n");
   $cols = $auth_user->attribs["Textarea Width"]->value;
   if(!$cols) $cols = 60;
   $rows = $auth_user->attribs["Textarea Height"]->value;
   if(!$rows) $rows = 20;
   printf("<textarea name=text wrap=off cols=%s rows=%s>", $cols, $rows);
   echo htmlspecialchars($content);
   printf("</textarea><br>\n");

   printf("<input type=submit name=\"save_button\" " .
	  "value=\"Create File\">\n");

   echo "</form>\n";
}

function new_html_form($auth_user)
{
   global $page;

   //printf("New PHP form.<br>\n");
   
   if(!$page) $page = $auth_user->attribs["homedir"]->value;
   
   if(! auth_is_dir($auth_user, $page))
   {
      printf("Invalid directory.<br>\n");
      return;
   }

   if(! auth_has_write($auth_user, $page))
   {
      printf("Unauthorized.<br>\n");
      return;
   }


   $content = "<html>\n<head>\n<title>New Page</title>\n</head>\n" .
      "<body>\n" .
      "Put your content here.\n" .
      "\n" .
      "</body>\n</html>\n";

   $target = link_to_self("action", "create_new_file");
   printf("<form method=post action=\"%s\">\n", $target);

   printf("File Name:\n");
   printf("<input type=text name=filename value=\"new.html\"><br>\n");
   $cols = $auth_user->attribs["Textarea Width"]->value;
   if(!$cols) $cols = 60;
   $rows = $auth_user->attribs["Textarea Height"]->value;
   if(!$rows) $rows = 20;
   printf("<textarea name=text wrap=off cols=%s rows=%s>", $cols, $rows);
   echo htmlspecialchars($content);
   printf("</textarea><br>\n");

   printf("<input type=submit name=\"save_button\" " .
	  "value=\"Create File\">\n");

   echo "</form>\n";
}

function new_dir_form($auth_user)
{
   global $page;

   if(!$page) $page = $auth_user->attribs["homedir"]->value;
   
   if(! auth_is_dir($auth_user, $page))
   {
      printf("Invalid directory.<br>\n");
      return;
   }

   if(! auth_has_write($auth_user, $page))
   {
      printf("Unauthorized.<br>\n");
      return;
   }

   $target = link_to_self("action", "create_new_dir");
   printf("<form method=post action=\"%s\">\n", $target);

   printf("Directory Name:\n");
   printf("<input type=text name=filename value=\"new_dir\">\n");

   printf("<input type=submit name=\"save_button\" " .
	  "value=\"Create Directory\">\n");

   echo "</form>\n";
}

function new_img_form($auth_user)
{
}

function new_file_form($auth_user)
{
   global $page;

   //$vpath = dirname($page);
   $vpath = $page;

   //printf("VPath: %s<br>\n", $vpath);
   
   // File upload form...
   $target = link_to_self("action", "upload_file");
   printf("<form ENCTYPE=\"multipart/form-data\" " .
	  "type=\"multipart/data\" method=post " .
	  "action=\"%s\">\n",
	  $target);
   printf("Upload a file:\n");
   printf("<input type=hidden name=page value=\"\">\n");
   printf("<input type=hidden name=vpath value=\"%s\">\n",
	  $vpath);
   printf("<input type=file name=\"upload_file\">\n");
   printf("<input type=submit value=\"Send file\">\n");
   printf("</form>\n");
   
   //printf("foo<br>\n");

}

function handle_add_file($auth_user)
{
   global $add_file_select;

   printf("Add file: %s<br>\n", $add_file_select);

   $file_functions = array(
      "new_ez" => new_ez_form,
      "new_php" => new_php_form,
      "new_html" => new_html_form,
      "new_dir" => new_dir_form,
      //"new_img" => new_img_form,
      "new_file" => new_file_form,
      );

   $found = 0;
   foreach($file_functions as $name => $func)
   {
      if ($name == $add_file_select)
      {
	 $found = 1;
	 $func($auth_user);
	 break;
      }
   }

   if (! $found)
   {
      printf("Invalid file type.<br>\n");
   }
}

function dir_edit($auth_user, $page, $files=0)
{
   // TODO: create links for each directory part
   // TODO: Make the rename/cut/copy/delete buttons work
   // TODO: Add more file attributes to display (mtime, size, ...)
   global $EDIT_DOCUMENT_ROOT;
   global $EDIT_DOMAIN;
   //global $encode_trans;
   global $rename_button;
   global $cut_button;
   global $copy_button;
   global $paste_button;
   global $delete_button;

   if($delete_button)
   {
      delete_files(&$auth_user);
   }
   else if ($copy_button)
   {
      handle_copy_button(&$auth_user);
   }
   else if ($cut_button)
   {
      handle_cut_button(&$auth_user);
   }
   else if ($paste_button)
   {
      handle_paste_button(&$auth_user);
   }
   else if ($rename_button)
   {
      handle_rename_button(&$auth_user);
      return;
   }

   print "<table class=\"edit_top_box\"><tr><td class=\"edit_help\">\n";
   print "<a href=\"help.php\">Help</a> on this Edit System.\n";
   print "</td>\n";
   
   // Form to create new files
   print "<td class=\"edit_new\">\n";
   $url = link_to_self("action", "add_file_form");
   $add_types = array(
      "Select type to add..." => "",
      "EZ page" => "new_ez",
      "PHP page" => "new_php",
      "HTML page" => "new_html",
      "Directory" => "new_dir",
      //"Image" => "new_img",
      "Upload a File" => "new_file",
      );
   printf("<form action=\"%s\" method=\"post\">\n", $url);
   printf("<select name=\"add_file_select\">\n");
   foreach($add_types as $text => $name)
   {
      printf("<option value=\"%s\">%s</option>\n",
	     $name, $text);
   }
   printf("</select>\n");
   printf("<input type=\"submit\" name=\"add_file_button\" value=\"Add...\">\n");
   printf("</form>\n");
   print "</td>\n";
   print "</tr></table>\n";
   

   // Main dir browser form
   printf("<form action=\"%s\" name=\"dirbrowser\" method=\"post\">\n",
	  "index.php?page={$page}");

   echo "<div class=\"edit_box\">\n";

   echo "<table class=\"edit_title\"><tr><td class=\"edit_path\">\n";

   // Display a full path to current directory, containing links
   // to each part of the path
   //printf("Directory of %s\n", $page);
   printf("Directory of \n");
   $page_parts = split("/", $page);
   //$page_parts[0] = "sitename.com";

   $page_joined = "";
   for($i = 0; $i < sizeof($page_parts); $i++)
   {
      $part = $page_parts[$i];
      if($i == 0)
      {
	 //$url = link_to_self("page", "/");
	 $url = "index.php?page=/";
	 printf("<a href=\"%s\">%s</a>\n",
		$url, "www");
      }
      else if($part)
      {
	 $page_joined = $page_joined . "/" . $part;
	 //$url = link_to_self("page", $page_joined);
	 $url = "index.php?page={$page_joined}";
	 printf("/<a href=\"%s\">%s</a>\n",
		$url, $part);
      }
   }
   
   printf("</td><td class=\"preview_link\">\n");
   $correct_url = "http:/{$page}";
   $correct_url = "{$EDIT_DOMAIN}{$page}";
   printf("<a href=\"%s\">View as web page</a>\n", $correct_url);
   echo "</td></tr></table>\n";

   $result = auth_read_dir($auth_user, $page);
   if(!$result)
   {
      printf("Unauthorized.<br>\n");
      echo "</div>\n";
      return;
   }
   $files = $result[0];
   $path = $result[1];

   // load user's allowed file types
   $ext_txt = $auth_user->attribs["edit extensions"]->value;
   if($ext_txt) { $extensions = explode(",", $ext_txt); }
   else { $extensions = array(); }

   // Display all the files in current directory
   echo "<table class=\"dir_box\">\n";
   $count = 0;
   foreach($files as $f)
   {
      $vpath = "/" . $page . "/" . $f;
      $vpath = path_normalize($vpath);
      $path = $EDIT_DOCUMENT_ROOT . $vpath;
      //printf("Path: %s<br>\n", $path);
      
      // determine if user is allowed to view this file type
      if(is_file($path)) {
	$pparts = pathinfo($f);
	$ext = $pparts['extension'];
	$found = 0;
	foreach($extensions as $e)
	{
	   if($e == $ext) {$found = 1;}
	}
	if ((!$found)  &&  sizeof($extensions) > 0) { continue; }
      }

      $odd = $count % 2;
      
      $trclass = "file_even";
      if($odd) { $trclass = "file_odd"; }

      $ftype = "file";
      if(is_dir($path))
      {
	 $ftype = "dir";
	 $trclass = "dir_even";
	 if ($odd) { $trclass = "dir_odd"; }
      }

      //$page_link_url = link_to_self("page", $vpath);
      $page_link_url = "index.php?page={$vpath}";
      
      echo "  <tr class=\"{$trclass}\">\n";
      printf("    <td class=\"fcheck\"><input type=\"checkbox\" " .
	     "name=\"filelist:%s\" /></td>\n", trans_var($vpath));
      printf("    <td class=\"fname\">" .
	     "<a href=\"{$page_link_url}\">{$f}</a></td>\n");
      printf("    <td class=\"ftype\">{$ftype}</td>\n");
      echo "  </tr>\n";
      $count = $count + 1;
   }
   echo "</table>\n";

   echo "<div class=\"edit_buttons\">\n";

   // Display all the file operation buttons...
   // Rename, cut, copy, paste, delete
   echo "  <input type=\"submit\" name=\"rename_button\" value=\"Rename\">\n";
   echo "  <input type=\"submit\" name=\"cut_button\" value=\"Cut\">\n";
   echo "  <input type=\"submit\" name=\"copy_button\" value=\"Copy\">\n";
   // If user has anything on the clipboard, enable "paste"
   if($auth_user->filelist)
   {
      echo "  <input type=\"submit\" name=\"paste_button\" value=\"Paste\">\n";
   }
   echo "  <input type=\"submit\" name=\"delete_button\" value=\"Delete\">\n";

   echo "</div>\n";

   echo "</form>\n";

   // If the user has anything on the clipboard, list it.
   if($auth_user->filelist)
   {
      printf("<b>Clipboard (%s):</b><br>\n", $auth_user->filemode);
      printf("<ul>\n");
      foreach ($auth_user->filelist as $f)
      {
	 printf("<li>%s</li>\n", $f);
      }
      printf("</ul>\n");
   }
   
}

function init_rte()
{
  global $wwwroot;
  $url = "{$wwwroot}/user/edit/gfx/rte/";
?>
  <script language="JavaScript" type="text/javascript">
    <!--
    //Usage: initRTE(imagesPath, includesPath, cssFile, genXHTML)
		<?
    echo "initRTE(\"{$url}\", \"\", \"\", true);\n";
		?>
    //-->
  </script>
<?
}

function print_rtesubmitform()
{
?>
  <script language="JavaScript" type="text/javascript">
    <!--
    function submitForm() {
      //make sure hidden and iframe values are in sync before submitting form
      //to sync only 1 rte, use updateRTE(rte)
      //to sync all rtes, use updateRTEs
      updateRTE('rte1');
      //updateRTEs();

      //change the following line to true to submit form
      return true;
    }
    //-->
  </script>
  <noscript><p><b>Javascript must be enabled to use this form.</b></p></noscript>
<?
}
function rteSafe($strText) 
{
  //returns safe code for preloading in the RTE
  $tmpString = $strText;

  //convert all types of single quotes
  $tmpString = str_replace(chr(145), chr(39), $tmpString);
  $tmpString = str_replace(chr(146), chr(39), $tmpString);
  $tmpString = str_replace("'", "&#39;", $tmpString);

  //convert all types of double quotes
  $tmpString = str_replace(chr(147), chr(34), $tmpString);
  $tmpString = str_replace(chr(148), chr(34), $tmpString);
  //      $tmpString = str_replace("\"", "\"", $tmpString);

  //replace carriage returns & line feeds
  $tmpString = str_replace(chr(10), " ", $tmpString);
  $tmpString = str_replace(chr(13), " ", $tmpString);

  return $tmpString;
}

function rte_editor($auth_user, $page, $path, $fp)
{
  global $wwwroot;
  $url = "{$wwwroot}/user/edit";
  ?>
  <script language="JavaScript" type="text/javascript" src="<?=$url?>/html2xhtml.js"></script>
  <!-- To decrease bandwidth, use richtext_compressed.js instead of richtext.js //-->
  <script language="JavaScript" type="text/javascript" src="<?=$url?>/richtext.js"></script>
  <?
  // set up a RTE form
  print_rtesubmitform();
  init_rte();

  /*
  // attempt to un-break image links inside the editor...
  // (it doesn't work yet)
  global $EDIT_DOMAIN;
  $url = $EDIT_DOMAIN . dirname($page) . "/";
  // echo "base: {$page} -> {$url}<br />\n";
  echo "<base href=\"{$url}\" />\n";
  */

  printf("%s:<br>\n", $page);

  $cols = 10 * $auth_user->attribs["Textarea Width"]->value;
  if(!$cols) $cols = 600;
  $rows = 10 * $auth_user->attribs["Textarea Height"]->value;
  if(!$rows) $rows = 300;

  $data = fread($fp, filesize($path));
  //$data = htmlspecialchars($data);
  $data = rteSafe($data);
  ?> 
  <script language="JavaScript" type="text/javascript">
    <!--
    //Usage: writeRichText(fieldname, html, width, height, buttons, readOnly)
    writeRichText('rte1', '<?=$data;?>', <?=$cols;?>, <?=$rows;?>, true, false);
    //-->
  </script>
  <?
}

function plain_editor($auth_user, $page, $path, $fp)
{
  // Display the file contents in a text area...
  $cols = $auth_user->attribs["Textarea Width"]->value;
  if(!$cols) $cols = 60;
  $rows = $auth_user->attribs["Textarea Height"]->value;
  if(!$rows) $rows = 20;
  printf("<textarea name=\"text\" wrap=\"off\" cols=\"%s\" rows=\"%s\">", $cols, $rows);
  $data = fread($fp, filesize($path));
  // data must be translated to display in a browser
  echo htmlspecialchars($data);
  printf("</textarea><br>\n");
}

function edit_page($auth_user, $page="")
{
   // if file is a dir:  call edit_dir()
   // else: check for pressed form buttons
   //       do appropriate action, checking for auth as needed
   global $PHP_SELF;
   global $save_button;
   global $upload_button;
   global $EDIT_DOMAIN;

   //printf("edit_page(<i><b>%s</b></i>);<br>\n", $page);

   if(!$page) $page = $auth_user->attribs["homedir"]->value;
   
   if(auth_is_dir($auth_user, $page))
   {
      return dir_edit(&$auth_user, $page);
   }
   
   $button_pressed = "";
   if($save_button) { $button_pressed = "save"; }
   elseif($upload_button) { $button_pressed = "upload"; }
   

   if(!$button_pressed)
   {
      // TODO: move this to a function
      // Read file contents
      $result = auth_read_file($auth_user, $page);
      if(!$result)
      {
         printf("Unauthorized.<br>\n");
      	 return;
      }
      $fp = $result[0];
      $path= $result[1];
      // File is a directory
      if (is_array($fp))
      {
         printf("Error: File is a directory, but was not detected.<br>\n");
      	 return;
      	 //return dir_edit(&$auth_user, $page, $fp);
      }


      // Display the current page, and a link to view it
      printf("<table width=\"100%%\"><tr><td>\n");
      printf("File edit:\n");
      $page_parts = split("/", $page);
      
      $page_joined = "";
      for($i = 0; $i < sizeof($page_parts); $i++)
      {
	 $part = $page_parts[$i];
	 if($i == 0)
	 {
	    //$url = link_to_self("page", "/");
	    $url = "index.php?page=/";
	    printf("<a href=\"%s\">%s</a>\n",
		   $url, "www");
	 }
	 else if($part)
	 {
	    $page_joined = $page_joined . "/" . $part;
	    $url = sprintf("index.php?page=%s", $page_joined);
	    printf("/<a href=\"%s\">%s</a>\n",
		   $url, $part);
	 }
      }

      // Display a link to view current page as a web page
      printf("</td><td align=right>\n");
      $public_link = "http:/{$page}";
      $public_link = "{$EDIT_DOMAIN}{$page}";
      printf("<a href=\"%s\">%s</a><br>\n",
	     $public_link, "View as web page");
      printf("</td></tr></table>\n");

      $target = link_to_self("action", "save_file");
      printf("<form method=post action=\"%s\" onsubmit=\"return submitForm();\">\n", $target);

      // decide which editor to use...
      $foo = pathinfo($path);
      $ext = $foo['extension'];
      global $rte_allowed, $binaries;
      if (in_array($ext, $rte_allowed)) 
      {
	rte_editor($auth_user, $page, $path, $fp);
      }
      elseif (in_array($ext, $binaries))
      {
        echo "Cannot edit binary files.<br /><br />";
      }
      else
      {
	plain_editor($auth_user, $page, $path, $fp);
      }

      if(auth_has_write($auth_user, $page))
      {
	 printf("<input type=submit name=\"save_button\" " .
		"value=\"Save Changes\">\n");
      }
   
      echo "</form>\n";

      // File upload form...
      if(auth_has_write($auth_user, $page))
      {
	 $target = link_to_self("action", "upload_file");
	 printf("<form ENCTYPE=\"multipart/form-data\" " .
		"type=\"multipart/data\" method=post " .
		"action=\"%s\">\n",
		$target);
	 printf("Upload a file:\n");
	 //printf("<input type=hidden name=page value=>\n");
	 printf("<input type=file name=\"upload_file\">\n");
	 printf("<input type=submit value=\"Send file\">\n");
	 printf("</form>\n");
      }
   }
}

function handle_upload($auth_user)
{
   global $EDIT_DOCUMENT_ROOT;
   global $HTTP_POST_VARS;
   global $HTTP_POST_FILES;
   global $upload_file, $upload_file_name, $upload_file_size,
      $upload_file_tmp_name;
   global $page;
   global $vpath;

   if(! $page)
   {
      $page = basename($HTTP_POST_FILES["upload_file"]["name"]);
      $page = $vpath . "/" . $page;
   }
   if(substr($page, 0, 1) != "/")
   {
      printf("Invalid upload path.<br>\n");
      return;
   }
   
   $virt_dest = $page;
   $real_dest = sprintf("%s/%s", $EDIT_DOCUMENT_ROOT, $page);

   //printf("name: %s<br>\n", $HTTP_POST_FILES["upload_file"]["name"]);
   //printf("size: %s<br>\n", $HTTP_POST_FILES["upload_file"]["size"]);
   //printf("tmp: %s<br>\n", $HTTP_POST_FILES["upload_file"]["tmp_name"]);
   
   if((! $HTTP_POST_FILES["upload_file"]["name"])  or
      (! $HTTP_POST_FILES["upload_file"]["size"])  or
      (! $HTTP_POST_FILES["upload_file"]["tmp_name"]))
   {
      printf("File upload failed.<br>\n");
      return;
   }

   if (is_uploaded_file($upload_file)) {
      if(auth_has_write($auth_user, $virt_dest))
      {
	 //printf("Copy %s -> %s<br>\n",
	 //$HTTP_POST_FILES["upload_file"]["tmp_name"],
	 //	$real_dest);
	 copy($HTTP_POST_FILES["upload_file"]["tmp_name"],
	      $real_dest);
	 printf("File uploaded.<br>\n");
	 
	 edit_page($auth_user, $vpath);
      }
      else
      {
	 printf("Unauthorized.<br>\n");
      }
   } else {
      echo "Possible file upload attack: filename {$userfile}.\n";
   }
}

function handle_save_file($auth_user)
{
   global $EDIT_DOCUMENT_ROOT;
   global $HTTP_POST_VARS;
   global $page;
   global $text;
   global $rte1;
   global $save_button;

   if($rte1) {$text = $rte1;}

   $save_button = "";

   $virt_dest = $page;
   $real_dest = sprintf("%s/%s", $EDIT_DOCUMENT_ROOT, $page);
   $backup_file = "{$real_dest}~";

   if(is_dir($real_dest))
   {
      printf("Error:  Attempt to save file but file is a directory.<br>\n");
      return;
   }
   
   //printf("Text:<br>\n");
   //printf("<hr>\n<pre>%s</pre>\n<hr>\n", $text);

   $content = reverse_htmlspecialchars($text);
   $content = str_replace("\r\n", "\n", $content);
   $content = str_replace("\n\r", "\n", $content);
   
   //printf("Content:<br>\n");
   //printf("<hr>\n<pre>%s</pre>\n<hr>\n", $content);


   if(auth_has_write($auth_user, $virt_dest))
   {
      //printf("Copy %s -> %s<br>\n",
      //$HTTP_POST_FILES["upload_file"]["tmp_name"],
      //	$real_dest);
      //copy($HTTP_POST_FILES["upload_file"]["tmp_name"],
      //$real_dest);
      copy($real_dest, $backup_file);

      // TODO? move orig file, then create new and fix perms
      
      $fp = fopen($real_dest, "wb", 0);
      fwrite($fp, $content);
      fclose($fp);
      // Explicitly work around a broken "feature"
      // which causes writes followed by reads to fail.
      clearstatcache();
      printf("Changes saved.<br>\n");

      $page = path_normalize($page);
      //printf("Edit %s<br>\n", $page);
      edit_page(&$auth_user, $page);
   }
   else
   {
      printf("Unauthorized.<br>\n");
   }
}

function edit_stuff($auth_user)
{
   global $page;
   global $action;

   $db = connect_db();
   
   $auth_user = edit_check_perm($auth_user);
   $num_perms = sizeof($auth_user->perm);
   if(!$num_perms)
   {
      printf("User has no permission.<br>\n");
      return;
   }
   
   if(! $action  or  $action == "file_edit")
   {
      if ($page)
      {
	 $page = path_normalize($page);
	 edit_page(&$auth_user, $page);
      }
      else
      {
	 printf("Home directory for %s: %s<br>\n",
		$auth_user->realname, $auth_user->attribs["homedir"]->value);
	 edit_page(&$auth_user);
      }
   }
   else if ($action == "save_file")
   {
      handle_save_file(&$auth_user);
   }
   else if ($action == "upload_file")
   {
      handle_upload(&$auth_user);
   }
   else if ($action == "add_file_form")
   {
      handle_add_file(&$auth_user);
   }
   else if ($action == "create_new_file")
   {
      handle_create_file(&$auth_user);
   }
   else if ($action == "create_new_ez")
   {
      handle_create_ez(&$auth_user);
   }
   else if ($action == "create_new_dir")
   {
      handle_create_dir(&$auth_user);
   }
   else if ($action == "rename")
   {
      handle_rename_form(&$auth_user);
   }
}

function user_page($auth_user)
{
   edit_stuff(&$auth_user);
}

check_login("edit");
?>

<? include("footer.inc"); ?>
