<? include("std.inc"); ?>
<? $title = "{$site_name} Link Admin Documentation"; ?>
<? include("header.inc"); ?>
<?

function user_page($auth_user)
{
   blurb("How to use the Link Editor");
   ?>
   
   This is an overview and reference for the functionality of the Link
   Editor.  It has two main screens, the List and the Editor.
   <?   
   blurb_end();

   blurb("List View");
   ?>

   The List view shows a table of all links in the system.  Each row is a
   link item, and each column is a data field.   The columns are:

   <table border=0>
   <?
     $titles = array("ID", "Title", "URL", "Section", "Approved", "Delete",
		     );
     $data = array("The database identifier for this link item.  You cannot edit this.",
		   "The name of the link, as it will appear (in large text) on the main links page.",
		   "The address this link points to.  It can be any valid URL/URI.",
		   "Which link category does this item go into?",
		   "Items will not show on the public links page until they are approved.",
		   "To get rid of a link item...",
		   );
     $click = array("Click to edit the link item on this row.",
		    "Click to edit the link item on this row.",
		    "Click to edit the link item on this row.",
		    "Click to see all links in this category.",
		    "Click to see all links with this approved status.",
		    "Click to delete this link item.",
		    );
     for($i=0; $titles[$i]; $i++)
     {
        print "<tr><td align=right valign=top><strong>{$titles[$i]}</strong></td>\n";
        print "<td align=left valign=top>{$data[$i]}</td>\n";
        print "<td align=left valign=top>{$click[$i]}</td></tr>\n";
     } 
   
   ?>
   </table>
   <p>   
   <strong>Notes:</strong>
   <ul>
     <li>Section names are case-sensitive.</li>
     <li>Each URL, Title, and Section is limited to 255 letters in length.</li>
     <li>Delete does not ask for confirmation, so be sure before you click!</li>
     <li>User-suggested links will have a wide variety of things which will need to be fixed before the links are approved.</li>
     <li>The categories displayed on the public links page are defined by the menu file for that page.  If you add new categories to the database, you should also add them to that menu.</li>
     <li>The default section displayed on the public links page is "featured".</li>
     <li>Links are sorted first by Approved status, then by Section, then Title.  This puts the unapproved links first, and groups categories together.</li>
   </ul>
   <? 
   blurb_end();

   blurb("Editor View");
   ?>

   The Link Editor is where you check links, change them, and approve them.
   You can edit the Title, URL, Description, Section, and Approved status.
   Be sure each field is filled out, spelled correctly, and says what you
   want it to say before approving the link.   The link is provided in a 
   clickable form to make it easier to verify.
   <p>   
   <strong>Notes:</strong>
   <ul>
     <li>Try to make sure each link has a description before approval.</li>
     <li>It may be necessary to follow the link and make up a description, if the user leaves the description empty.</li>
     <li>Be sure to check each URL before approving new links!</li>   
   </ul>
   <?
   blurb_end();
}

// Authenticates the user, and calls user_page() if successful.
// Argument is the name of a group the user must be in.
check_login("links");
?>

<? include("footer.inc"); ?>
